"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNhsNumber = exports.generateInvalidNhsNumbers = exports.generateValidNhsNumbers = void 0;
const faker_1 = __importDefault(require("faker"));
function generateValidNhsNumbers(num) {
    const numbers = [];
    while (numbers.length < num) {
        const number = faker_1.default.random.number({ min: 100000000, max: 999999999 }).toString();
        const multipliedTotal = number.split('').reduce((acc, curr, i) => acc + (Number(curr) * (10 - i)), 0);
        const remainder = multipliedTotal % 11;
        let checkDigit = 11 - remainder;
        if (checkDigit === 11) {
            checkDigit = 0;
        }
        if (checkDigit !== 10) {
            numbers.push(`${number}${checkDigit}`);
        }
    }
    return numbers;
}
exports.generateValidNhsNumbers = generateValidNhsNumbers;
function generateInvalidNhsNumbers(num) {
    const numbers = [];
    while (numbers.length < num) {
        let checkDigit;
        const number = faker_1.default.random.number({ min: 100000000, max: 999999999 }).toString();
        const multipliedTotal = number.split('').reduce((acc, curr, i) => acc + (Number(curr) * (10 - i)), 0);
        const remainder = multipliedTotal % 11;
        checkDigit = 11 - remainder;
        if (checkDigit === 10) {
            numbers.push(`${number}${checkDigit}`);
        }
    }
    return numbers;
}
exports.generateInvalidNhsNumbers = generateInvalidNhsNumbers;
const generateNhsNumber = () => generateValidNhsNumbers(1)[0];
exports.generateNhsNumber = generateNhsNumber;
